diff --git a/gcc/analyzer/diagnostic-manager.cc b/gcc/analyzer/diagnostic-manager.cc
index d3ed085b712..920c8ce82f7 100644
--- a/gcc/analyzer/diagnostic-manager.cc
+++ b/gcc/analyzer/diagnostic-manager.cc
@@ -2172,113 +1936,57 @@ diagnostic_manager::add_events_for_eedge (const path_builder &pb,
   for_each_state_change (src_state, dst_state, pb.get_ext_state (),
 			 &visitor);
 
+  /* Give diagnostics an opportunity to inject extra events, or
+     to override the rest of this function.  */
+  pending_diagnostic *pd = pb.get_pending_diagnostic ();
+  if (pd->maybe_add_custom_events_for_eedge (eedge, emission_path))
+    return;
+
   /* Allow non-standard edges to add events, e.g. when rewinding from
      longjmp to a setjmp.  */
   if (eedge.m_custom_info)
-    eedge.m_custom_info->add_events_to_path (emission_path, eedge);
+    eedge.m_custom_info->add_events_to_path (emission_path, eedge, *pd);
 
-  /* Add events for superedges, function entries, and for statements.  */
-  switch (dst_point.get_kind ())
+  /* Don't add events for insignificant edges at verbosity levels below 3.  */
+  if (m_verbosity < 3)
+    if (!significant_edge_p (pb, eedge))
+      return;
+
+  /* Add events for operations.  */
+  if (eedge.m_sedge)
+    if (auto op = eedge.m_sedge->get_op ())
+      op->add_any_events_for_eedge (eedge, *emission_path);
+
+  /* Add events for function entry.  */
+  if (dst_point.get_supernode ()->entry_p ())
     {
-    default:
-      break;
-    case PK_BEFORE_SUPERNODE:
-      if (src_point.get_kind () == PK_AFTER_SUPERNODE)
-	{
-	  if (eedge.m_sedge)
-	    add_events_for_superedge (pb, eedge, emission_path);
-	}
-      /* Add function entry events.  */
-      if (dst_point.get_supernode ()->entry_p ())
+      pb.get_pending_diagnostic ()->add_function_entry_event
+	(eedge, emission_path);
+      /* Create region_creation_events for on-stack regions within
+	 this frame.  */
+      if (interest)
 	{
-	  pb.get_pending_diagnostic ()->add_function_entry_event
-	    (eedge, emission_path);
-	  /* Create region_creation_events for on-stack regions within
-	     this frame.  */
-	  if (interest)
-	    {
-	      unsigned i;
-	      const region *reg;
-	      FOR_EACH_VEC_ELT (interest->m_region_creation, i, reg)
-		if (const frame_region *frame = reg->maybe_get_frame_region ())
-		  if (frame->get_fndecl () == dst_point.get_fndecl ())
-		    {
-		      const region *base_reg = reg->get_base_region ();
-		      if (tree decl = base_reg->maybe_get_decl ())
-			if (DECL_P (decl)
-			    && DECL_SOURCE_LOCATION (decl) != UNKNOWN_LOCATION)
-			  {
-			    emission_path->add_region_creation_events
-			      (pb.get_pending_diagnostic (),
-			       reg, dst_state.m_region_model,
-			       event_loc_info (DECL_SOURCE_LOCATION (decl),
-					       dst_point.get_fndecl (),
-					       dst_stack_depth),
-			       m_verbosity > 3);
-			  }
-		    }
-	    }
-	}
-      break;
-    case PK_BEFORE_STMT:
-      {
-	const gimple *stmt = dst_point.get_stmt ();
-	const gcall *call = dyn_cast <const gcall *> (stmt);
-	if (call && is_setjmp_call_p (*call))
-	  emission_path->add_event
-	    (std::make_unique<setjmp_event>
-	       (event_loc_info (stmt->location,
-				dst_point.get_fndecl (),
-				dst_stack_depth),
-		dst_node,
-		*call));
-	else
-	  emission_path->add_event
-	    (std::make_unique<statement_event> (stmt,
-						dst_point.get_fndecl (),
-						dst_stack_depth, dst_state));
-
-	/* Create state change events for assignment to NULL.
-	   Iterate through the stmts in dst_enode, adding state change
-	   events for them.  */
-	if (dst_state.m_region_model)
-	  {
-	    log_scope s (get_logger (), "processing run of stmts");
-	    program_state iter_state (dst_state);
-	    program_point iter_point (dst_point);
-	    while (1)
-	      {
-		const gimple *stmt = iter_point.get_stmt ();
-		if (const gassign *assign = dyn_cast<const gassign *> (stmt))
-		  {
-		    const extrinsic_state &ext_state = pb.get_ext_state ();
-		    program_state old_state (iter_state);
-		    iter_state.m_region_model->on_assignment (assign, nullptr);
-		    for (unsigned i = 0; i < ext_state.get_num_checkers (); i++)
+	  unsigned i;
+	  const region *reg;
+	  FOR_EACH_VEC_ELT (interest->m_region_creation, i, reg)
+	    if (const frame_region *frame = reg->maybe_get_frame_region ())
+	      if (frame->get_fndecl () == dst_point.get_fndecl ())
+		{
+		  const region *base_reg = reg->get_base_region ();
+		  if (tree decl = base_reg->maybe_get_decl ())
+		    if (DECL_P (decl)
+			&& useful_location_p (DECL_SOURCE_LOCATION (decl)))
 		      {
-			const state_machine &sm = ext_state.get_sm (i);
-			null_assignment_sm_context sm_ctxt (i, sm,
-							    &old_state,
-							    &iter_state,
-							    stmt,
-							    &iter_point,
-							    emission_path,
-							    pb.get_ext_state ());
-			sm.on_stmt (sm_ctxt, dst_point.get_supernode (), stmt);
-			// TODO: what about phi nodes?
+			emission_path->add_region_creation_events
+			  (pb.get_pending_diagnostic (),
+			   reg, dst_state.m_region_model,
+			   event_loc_info (DECL_SOURCE_LOCATION (decl),
+					   dst_point.get_fndecl (),
+					   dst_stack_depth),
+			   m_verbosity > 3);
 		      }
-		  }
-		iter_point.next_stmt ();
-		if (iter_point.get_kind () == PK_AFTER_SUPERNODE
-		    || (dst_node->m_succs.length () > 1
-			&& (iter_point
-			    == dst_node->m_succs[0]->m_dest->get_point ())))
-		  break;
-	      }
-
-	  }
-      }
-      break;
+		}
+	}
     }
 
   /* Look for changes in dynamic extents, which will identify
@@ -2408,122 +2116,6 @@ diagnostic_manager::significant_edge_p (const path_builder &pb,
   return true;
 }
 
-/* Subroutine of diagnostic_manager::add_events_for_eedge
-   where EEDGE has an underlying superedge i.e. a CFG edge,
-   or an interprocedural call/return.
-   Add any events for the superedge to EMISSION_PATH.  */
-
-void
-diagnostic_manager::add_events_for_superedge (const path_builder &pb,
-					      const exploded_edge &eedge,
-					      checker_path *emission_path)
-  const
-{
-  gcc_assert (eedge.m_sedge);
-
-  /* Give diagnostics an opportunity to override this function.  */
-  pending_diagnostic *pd = pb.get_pending_diagnostic ();
-  if (pd->maybe_add_custom_events_for_superedge (eedge, emission_path))
-    return;
-
-  /* Don't add events for insignificant edges at verbosity levels below 3.  */
-  if (m_verbosity < 3)
-    if (!significant_edge_p (pb, eedge))
-      return;
-
-  const exploded_node *src_node = eedge.m_src;
-  const program_point &src_point = src_node->get_point ();
-  const exploded_node *dst_node = eedge.m_dest;
-  const program_point &dst_point = dst_node->get_point ();
-  const int src_stack_depth = src_point.get_stack_depth ();
-  const int dst_stack_depth = dst_point.get_stack_depth ();
-  const gimple *last_stmt = src_point.get_supernode ()->get_last_stmt ();
-
-  switch (eedge.m_sedge->m_kind)
-    {
-    case SUPEREDGE_CFG_EDGE:
-      {
-	if (auto eh_dispatch_try_sedge
-	      = eedge.m_sedge->dyn_cast_eh_dispatch_try_cfg_superedge ())
-	  {
-	    if (eh_dispatch_try_sedge->get_eh_catch ())
-	      {
-		const region_model *model = src_node->get_state ().m_region_model;
-		auto curr_thrown_exception_node
-		  = model->get_current_thrown_exception ();
-		gcc_assert (curr_thrown_exception_node);
-		tree type = curr_thrown_exception_node->maybe_get_type ();
-		emission_path->add_event
-		  (std::make_unique<catch_cfg_edge_event>
-		   (eedge,
-		    event_loc_info (dst_point.get_supernode ()->get_start_location (),
-				    dst_point.get_fndecl (),
-				    dst_stack_depth),
-		    type));
-		return;
-	      }
-	    else
-	      {
-		/* We have the "uncaught exception" sedge, from eh_dispatch
-		   to a block containing resx.
-		   Don't add any events for this, so that we can consolidate
-		   adjacent stack unwinding events.  */
-		return;
-	      }
-	  }
-
-	emission_path->add_event
-	  (std::make_unique<start_cfg_edge_event>
-	     (eedge,
-	      event_loc_info
-		(last_stmt ? last_stmt->location : UNKNOWN_LOCATION,
-		 src_point.get_fndecl (),
-		 src_stack_depth)));
-	emission_path->add_event
-	  (std::make_unique<end_cfg_edge_event>
-	     (eedge,
-	      event_loc_info (dst_point.get_supernode ()->get_start_location (),
-			      dst_point.get_fndecl (),
-			      dst_stack_depth)));
-      }
-      break;
-
-    case SUPEREDGE_CALL:
-      pd->add_call_event (eedge, emission_path);
-      break;
-
-    case SUPEREDGE_INTRAPROCEDURAL_CALL:
-      {
-	/* TODO: add a subclass for this, or generate events for the
-	   summary.  */
-	emission_path->add_event
-	  (std::make_unique<debug_event>
-	     (event_loc_info (last_stmt
-			      ? last_stmt->location
-			      : UNKNOWN_LOCATION,
-			      src_point.get_fndecl (),
-			      src_stack_depth),
-	      "call summary"));
-      }
-      break;
-
-    case SUPEREDGE_RETURN:
-      {
-	const return_superedge *return_edge
-	  = as_a <const return_superedge *> (eedge.m_sedge);
-
-	const gcall &call_stmt = return_edge->get_call_stmt ();
-	emission_path->add_event
-	  (std::make_unique<return_event>
-	     (eedge,
-	      event_loc_info (call_stmt.location,
-			      dst_point.get_fndecl (),
-			      dst_stack_depth)));
-      }
-      break;
-    }
-}
-
 /* Prune PATH, based on the verbosity level, to the most pertinent
    events for a diagnostic that involves VAR ending in state STATE
    (for state machine SM).
@@ -2742,7 +2334,7 @@ diagnostic_manager::prune_for_sm_diagnostic (checker_path *path,
 	  /* Don't filter these.  */
 	  break;
 
-	case event_kind::call_edge:
+	case event_kind::call_:
 	  {
 	    call_event *event = (call_event *)base_event;
 	    const region_model *callee_model
@@ -2753,18 +2345,16 @@ diagnostic_manager::prune_for_sm_diagnostic (checker_path *path,
 	    callsite_expr expr;
 
 	    tree caller_var;
-            if(event->m_sedge)
-              {
-                const callgraph_superedge& cg_superedge
-                  = event->get_callgraph_superedge ();
-                if (cg_superedge.m_cedge)
-	          caller_var
-	            = cg_superedge.map_expr_from_callee_to_caller (callee_var,
-                                                                   &expr);
-                else
-                  caller_var = caller_model->get_representative_tree (sval);
-              }
-            else
+	    if (auto op = event->get_call_and_return_op ())
+	      {
+		tree callee_fndecl
+		  = event->m_eedge.m_dest->get_point ().get_fndecl ();
+		caller_var
+		  = op->map_expr_from_callee_to_caller (callee_fndecl,
+							callee_var,
+							&expr);
+	      }
+	    else
 	      caller_var = caller_model->get_representative_tree (sval);
 
 	    if (caller_var)
@@ -2783,7 +2373,7 @@ diagnostic_manager::prune_for_sm_diagnostic (checker_path *path,
 	  }
 	  break;
 
-	case event_kind::return_edge:
+	case event_kind::return_:
 	  {
 	    if (sval)
 	      {
@@ -2795,20 +2385,19 @@ diagnostic_manager::prune_for_sm_diagnostic (checker_path *path,
                   = event->m_eedge.m_src->get_state ().m_region_model;
 		callsite_expr expr;
 
-                tree callee_var;
-                if (event->m_sedge)
-                  {
-                    const callgraph_superedge& cg_superedge
-                      = event->get_callgraph_superedge ();
-                    if (cg_superedge.m_cedge)
-                      callee_var
-                        = cg_superedge.map_expr_from_caller_to_callee (caller_var,
-                                                                       &expr);
-                    else
-                      callee_var = callee_model->get_representative_tree (sval);
-                  }
-                else
-                  callee_var = callee_model->get_representative_tree (sval);
+		tree callee_var;
+
+		if (auto op = event->get_call_and_return_op ())
+		  {
+		    tree callee_fndecl
+		      = event->m_eedge.m_src->get_point ().get_fndecl ();
+		    callee_var
+		      = op->map_expr_from_caller_to_callee (callee_fndecl,
+							    caller_var,
+							    &expr);
+		  }
+		else
+		  callee_var = callee_model->get_representative_tree (sval);
 
 		if (callee_var)
 		  {
@@ -3118,15 +2707,16 @@ diagnostic_manager::consolidate_conditions (checker_path *path) const
 	  gcc_assert (old_start_ev->get_kind () == event_kind::start_cfg_edge);
 	  const start_cfg_edge_event *old_start_cfg_ev
 	    = (const start_cfg_edge_event *)old_start_ev;
-	  const cfg_superedge& first_cfg_sedge
-	    = old_start_cfg_ev->get_cfg_superedge ();
 	  bool edge_sense;
-	  if (first_cfg_sedge.true_value_p ())
-	    edge_sense = true;
-	  else if (first_cfg_sedge.false_value_p ())
-	    edge_sense = false;
-	  else
-	    continue;
+	  if (::edge e = old_start_cfg_ev->get_cfg_edge ())
+	    {
+	      if (e->flags & EDGE_TRUE_VALUE)
+		edge_sense = true;
+	      else if (e->flags & EDGE_FALSE_VALUE)
+		edge_sense = false;
+	      else
+		continue;
+	    }
 
 	  /* Find a run of CFG start/end event pairs from
 	       [start_idx, next_idx)
@@ -3141,16 +2731,17 @@ diagnostic_manager::consolidate_conditions (checker_path *path) const
 	      gcc_assert (iter_ev->get_kind () == event_kind::start_cfg_edge);
 	      const start_cfg_edge_event *iter_cfg_ev
 		= (const start_cfg_edge_event *)iter_ev;
-	      const cfg_superedge& iter_cfg_sedge
-		= iter_cfg_ev->get_cfg_superedge ();
+	      ::edge e = iter_cfg_ev->get_cfg_edge ();
+	      if (!e)
+		break;
 	      if (edge_sense)
 		{
-		  if (!iter_cfg_sedge.true_value_p ())
+		  if (!(e->flags & EDGE_TRUE_VALUE))
 		    break;
 		}
 	      else
 		{
-		  if (!iter_cfg_sedge.false_value_p ())
+		  if (!(e->flags & EDGE_FALSE_VALUE))
 		    break;
 		}
 	      next_idx += 2;
diff --git a/gcc/analyzer/diagnostic-manager.h b/gcc/analyzer/diagnostic-manager.h
index d9cf109080f..2b439fb603e 100644
--- a/gcc/analyzer/diagnostic-manager.h
+++ b/gcc/analyzer/diagnostic-manager.h
@@ -21,17 +21,60 @@ along with GCC; see the file COPYING3.  If not see
 #ifndef GCC_ANALYZER_DIAGNOSTIC_MANAGER_H
 #define GCC_ANALYZER_DIAGNOSTIC_MANAGER_H
 
+#include "analyzer/supergraph.h"
+#include "analyzer/event-loc-info.h"
+
 namespace ana {
 
 class epath_finder;
 
+/* A bundle of information capturing where a pending_diagnostic should
+   be emitted.  */
+
+struct pending_location
+{
+public:
+  class fixer_for_epath
+  {
+  public:
+    virtual ~fixer_for_epath () = default;
+
+    virtual void
+    fixup_for_epath (const exploded_path &epath,
+		     pending_location &ploc) const = 0;
+  };
+
+  pending_location ();
+  pending_location (exploded_node *enode);
+  pending_location (exploded_node *enode,
+		    location_t loc);
+
+  std::unique_ptr<json::object> to_json () const;
+
+  /* The enode with which a diagnostic is to be associated,
+     for tracking feasibility.  */
+  exploded_node *m_enode;
+
+  /* Information to use for the location of the warning,
+     and for the location of the "final warning" in the path.  */
+  event_loc_info m_event_loc_info;
+
+  /* Optional hook for use when eventually emitting the diagnostic
+     for fixing up m_event_loc_info based on the specific epath.  */
+  std::unique_ptr<fixer_for_epath> m_fixer_for_epath;
+};
+
+extern std::unique_ptr<pending_location::fixer_for_epath>
+make_ploc_fixer_for_epath_for_leak_diagnostic (const exploded_graph &eg,
+					       tree var);
+
 /* A to-be-emitted diagnostic stored within diagnostic_manager.  */
 
 class saved_diagnostic
 {
 public:
   saved_diagnostic (const state_machine *sm,
-		    const pending_location &ploc,
+		    pending_location &&ploc,
 		    tree var, const svalue *sval,
 		    state_machine::state_t state,
 		    std::unique_ptr<pending_diagnostic> d,
@@ -70,13 +113,11 @@ public:
   void
   maybe_add_sarif_properties (diagnostics::sarif_object &result_obj) const;
 
+  const supernode *get_supernode () const;
+
   //private:
   const state_machine *m_sm;
-  const exploded_node *m_enode;
-  const supernode *m_snode;
-  const gimple *m_stmt;
-  std::unique_ptr<stmt_finder> m_stmt_finder;
-  location_t m_loc;
+  pending_location m_ploc;
   tree m_var;
   const svalue *m_sval;
   state_machine::state_t m_state;
@@ -102,46 +143,6 @@ private:
 
 class path_builder;
 
-/* A bundle of information capturing where a pending_diagnostic should
-   be emitted.  */
-
-struct pending_location
-{
-public:
-  pending_location (exploded_node *enode,
-		    const supernode *snode,
-		    const gimple *stmt,
-		    const stmt_finder *finder)
-  : m_enode (enode),
-    m_snode (snode),
-    m_stmt (stmt),
-    m_finder (finder),
-    m_loc (UNKNOWN_LOCATION)
-  {
-    gcc_assert (m_stmt || m_finder);
-  }
-
-  /* ctor for cases where we have a location_t but there isn't any
-     gimple stmt associated with the diagnostic.  */
-
-  pending_location (exploded_node *enode,
-		    const supernode *snode,
-		    location_t loc)
-  : m_enode (enode),
-    m_snode (snode),
-    m_stmt (nullptr),
-    m_finder (nullptr),
-    m_loc (loc)
-  {
-  }
-
-  exploded_node *m_enode;
-  const supernode *m_snode;
-  const gimple *m_stmt;
-  const stmt_finder *m_finder;
-  location_t m_loc;
-};
-
 /* A class with responsibility for saving pending diagnostics, so that
    they can be emitted after the exploded_graph is complete.
    This lets us de-duplicate diagnostics, and find the shortest path
@@ -161,13 +162,13 @@ public:
   std::unique_ptr<json::object> to_json () const;
 
   bool add_diagnostic (const state_machine *sm,
-		       const pending_location &ploc,
+		       pending_location &&ploc,
 		       tree var,
 		       const svalue *sval,
 		       state_machine::state_t state,
 		       std::unique_ptr<pending_diagnostic> d);
 
-  bool add_diagnostic (const pending_location &ploc,
+  bool add_diagnostic (pending_location &&ploc,
 		       std::unique_ptr<pending_diagnostic> d);
 
   void add_note (std::unique_ptr<pending_note> pn);
@@ -212,10 +213,6 @@ private:
   bool significant_edge_p (const path_builder &pb,
 			   const exploded_edge &eedge) const;
 
-  void add_events_for_superedge (const path_builder &pb,
-				 const exploded_edge &eedge,
-				 checker_path *emission_path) const;
-
   void prune_path (checker_path *path,
 		   const state_machine *sm,
 		   const svalue *sval,
